$regfile = "m8def.dat"
$crystal = 8000000
$hwstack = 96
$swstack = 64
$framesize = 64

'     
Config Lcd = 16 * 2                               '  2   16 
Config Lcdbus = 4
Config Lcdmode = Port
Config Lcdpin = Pin , Db4 = Portb.0 , Db5 = Portb.1 , Db6 = Portb.2 , Db7 = Portb.3 , Rs = Portb.4 , E = Portb.5
Cls
Cursor Off

' 
Declare Sub Get_th(t As Byte , H As Byte)

'Config Serialin = Buffered , Size = 128
'Config Serialout = Buffered , Size = 128

'   PortD.6
Dht_put Alias Portc.2
Dht_get Alias Pinc.2
Dht_io_set Alias Ddrc.2

Dim T As Byte                        '   
Dim H As Byte                        '   
Dim Crc As Byte                      '    
Dim Mybyte As Byte
Dim Sensor_data As String * 40    '     
Dim Tmp_str8 As String * 8
Dim Count As Byte                    '    

Enable Interrupts

Set Dht_io_set
Set Dht_put

Lcd "AVRproject.ru"
Lowerline
Lcd "DHT11 sensor"

Do
   Waitms 1500
   Call Get_th(t , H)
   Cls
   Lcd "TMP: " ; T ; "C"
   Lowerline
   Lcd "PHP: " ; H ; "%"

Loop

Sub Get_th(t As Byte , H As Byte)

 Count = 0
 Sensor_data = ""
 Set Dht_io_set                                         ' PD.6 
 Reset Dht_put                                          '   
 Waitms 25                                              '   18

 Set Dht_put                                            ' 
 Waitus 40
 Reset Dht_io_set                                       ' PD.6 
 Waitus 40                                              ' 40 
 If Dht_get = 1 Then                                    '     1
    H = 1                                               '   
    Exit Sub                                            '  
 End If

'         
  Waitus 80                                             '  80 
  If Dht_get = 0 Then                                   '     0
    H = 2                                               '    
    Exit Sub                                            '  
  End If

'      ,  

  While Dht_get = 1 : Wend                '     1

   Do                                     '  40  
    While Dht_get = 0 : Wend              '    0
    Waitus 30                             '  0  30
     If Dht_get = 1 Then                  '   1
       Sensor_data = Sensor_data + "1"    '    
       While Dht_get = 1 : Wend           '      
       Else                               ',    0
       Sensor_data = Sensor_data + "0"    '  0  
    End If
    Incr Count                            '   1
   Loop Until Count = 40                  '      40

   Set Dht_io_set
   Set Dht_put

'   

   Tmp_str8 = Left(sensor_data , 8)                '  8  
   H = Binval(tmp_str8)                            '   

   Tmp_str8 = Mid(sensor_data , 17 , 8)            ' 8   
   T = Binval(tmp_str8)                            '   

   Tmp_str8 = Right(sensor_data , 8)               ' 8 
   Crc = Binval(tmp_str8)                          ' 

'  

   Mybyte = T + H                      '    
   If Mybyte <> Crc Then               '    
      H = 3                            '    
   End If

End Sub                                           '    