$regfile = "m8def.dat"
$crystal = 4000000
$hwstack = 96
$swstack = 64
$framesize = 64

$include "DHT_Lib.bas"

Config Lcd = 16 * 2                               '  2   16 
Config Lcdbus = 4
Config Lcdmode = Port
Config Lcdpin = Pin , Db4 = Portb.0 , Db5 = Portb.1 , Db6 = Portb.2 , Db7 = Portb.3 , Rs = Portb.4 , E = Portb.5

Cls
Cursor Off

Lcd "Init"
Wait 1


Dim Thermo As Integer , Humidity As Integer
Dim T As Single , H As Single
Dim Errcode As Byte

Do
   Cls
   Errcode = Dht_read(thermo , Humidity)
   If Errcode = Dht_ok Then

      T = Thermo / 10
      H = Humidity / 10

      Lcd "Thermo " ; Fusing(t , "###.#") ; " C"  '
      Lowerline
      Lcd "Humidity " ; Fusing(h , "###.#") ; " %"
   Else
     Lcd "Error code " ; Errcode
   End If

   Wait 1

Loop

End